\documentclass[a4paper]{article}
\usepackage[english]{babel}
\usepackage[T1]{fontenc}
\usepackage[a4paper, top=0.75cm, bottom=0.75cm, left=2cm, right=2cm]{geometry}
\usepackage{listings}
\usepackage{inconsolata}
\pagenumbering{gobble}
\lstset{frame=single, showstringspaces=false, columns=fixed, basicstyle={\ttfamily}, commentstyle={\it}, numbers=left, tabsize=4}
\begin{document}
\lstset{title=Contents of \texttt{README}}
\lstset{
  language=,
  morekeywords={NAME, SYNOPSIS, DESCRIPTION, NOTES, EXAMPLES, AUTHOR, COPYRIGHT},
  moredelim=[is][\it]{<|}{|>},
  moredelim=[is][\bf]{<:}{:>}
}
\begin{lstlisting}
NAME
        <:sigcounter:> - count the number of signals of each type the process
            recieves until a threshold is reached.

SYNOPSIS
        void <:waitEL:>(<|EventList|> e);
            Wait for all events in the <|EventList|> e to happen.

DESCRIPTION
        An <|Event|> is specified by a pair of numbers:
            int signo;      The signal number to wait for.
            size_t count;   The threshold, how many signals
                                are required for the Event.
        An <|EventList|> is simply a NULL-terminated array of <|Events|>.

EXAMPLES
        Examples are available in src/examples.c

AUTHOR
        Implemented by Stotskii Andrey (ruro).

COPYRIGHT
        Copyright (c) 2017 Free Software Foundation, Inc.  License GPLv3+:
        GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
        This is free software: you are free to change and redistribute it.
        There is NO WARRANTY, to the extent permitted by law.
\end{lstlisting}
\lstset{title=Contents of \texttt{makefile}}
\lstset{language={[gnu]make}}
\begin{lstlisting}
CFLAGS= -Wall -O3 -std=gnu99
LDFLAGS= -s -lm -lpthread
CC=gcc

vpath %.c src
vpath %.h src

examples:     sigcounter.h terminator.h sigcounter.o terminator.o forkshare.o
sigcounter.o: sigcounter.h terminator.h
terminator.o:              terminator.h forkshare.h
forkshare.o:               terminator.h forkshare.h

.PHONY:libs
libs: sigcounter.o terminator.o forkshare.o

.PHONY:clean
clean:
	rm -f *.o examples
\end{lstlisting}
\newpage
\lstset{language={[ANSI]C}}
\lstset{literate={float.}{float.}6}
\lstset{morekeywords={size_t, ssize_t, bool, pid_t, func, sem_t, Pipe, Task, TaskStream, Worker, Swarm}}
\lstset{moredelim=[s][\it]{__}{__}}
\lstset{moredelim=[s][\it]{((}{))}}
\lstset{title=Contents of \texttt{src/sigcounter.h}}
\begin{lstlisting}
#ifndef _SIGCOUNTER_H
#define _SIGCOUNTER_H

#include <stdlib.h>

typedef struct
{
    int signo;
    size_t count;
} Event;

typedef Event EventList[];

void waitEL(EventList) __attribute__(( nonnull ));

#endif
\end{lstlisting}
\lstset{title=Contents of \texttt{src/examples.c}}
\begin{lstlisting}
#include "sigcounter.h"
#include "terminator.h"

#include <signal.h>

int main(void)
{

    EventList e = {
        {SIGALRM, 10}, // Wait for SIGALRM to happen 10 times.
        {SIGWINCH, 3}, // Wait for SIGWINCH to happen 3 times.
        {0, 0}         // "NULL" - terminator.
    };
    announce("Waiting for signals SIGALRM(%d) and SIGWINCH(%d).\n",
                                  SIGALRM,        SIGWINCH);
    waitEL(e);
    announce("All signals recieved.\n");
}
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/sigcounter.c}}
\begin{lstlisting}
#include "sigcounter.h"
#include "terminator.h"

#include <stdbool.h>
#include <stdlib.h>
#include <errno.h>
#include <signal.h>

bool isELempty(EventList e)
{
    // Check if no Non-Zero events are left in EventList e.
    for (size_t i = 0; e[i].signo; i++)
        if (e[i].count)
            return false;
    return true;
}

void tick(EventList e, int sig)
{
    // Decrement the counter for signal sig in EventList e.
    for (size_t i = 0; e[i].signo; i++)
        if (e[i].signo == sig)
        {
            e[i].count -= !!e[i].count;
            announce("Recieved signal %d."
                    " Waiting for %zu more signals of this type.\n",
                    sig, e[i].count);
            return;
        }
}

void waitEL(EventList e)
{
    // Make a new signal mask from EventList.
    sigset_t old, cur;
    if (sigemptyset(&cur))
        terminate(errno, "Couldn't empty the set.\n");
    for (size_t i = 0; e[i].signo; i++)
        if (sigaddset(&cur, e[i].signo))
            terminate(errno, "Couldn't add signal to the set.\n");

    // Block the signals in the mask.
    if (sigprocmask(SIG_BLOCK, &cur, &old))
        terminate(errno, "Couldn't change signal mask.\n");

    // Wait for the signals.
    int sig;
    while (!isELempty(e))
    {
        while ((sig = sigwaitinfo(&cur, NULL)) == -1)
            if (errno != EINTR)
                terminate(errno, "Couldn't wait for required signals.\n");
        tick(e, sig);
    }

    // Restore the old signal mask.
    if (sigprocmask(SIG_SETMASK, &old, NULL))
        terminate(errno, "Couldn't restore the signal mask.\n");
}
\end{lstlisting}
\end{document}